View Issue Details

IDProjectCategoryView StatusLast Update
0004722OXID eShop (all versions)4.07. Source code, Testpublic2016-06-17 12:53
Reporterarturas.sevcenko 
PrioritynormalSeveritymajorReproducibilityalways
Status acknowledgedResolutionopen 
Product Version4.5.11 revision 46050 
Target VersionFixed in Version 
Summary0004722: Shop config is not reloaded on shop id change
DescriptionoxConfig::setShopid() can cause problems, if used after oxConfig::init() call, because it only changes shop id without triggering object reload / reinit
Steps To ReproduceReproduced by ERP SOAP plugin oxGetConfigParametersPlugin.
Additional InformationProblem is more generic, and can show up anywhere in ERP system where subshop configuration is any different than of the mainshop.
TagsERP, Subshops, Varnish
ThemeAll
BrowserAll
PHP VersionNot defined
MySQL VersionNot defined

Relationships

related to 0004538 resolvedarturas.sevcenko OXID ERP Interface In ERP calls getShopConfVar always select config params from Supershop but not from Subshop 
parent of 0005939 acknowledged OXID eShop (all versions) EE: AutoLoader does not work with ERP SOAP and Subshop Modules 
Not all the children of this issue are yet resolved or closed.

Activities

aurimas.gladutis

2013-02-07 15:20

reporter   ~0008390

Changing current logic of this place can make more problems than fix them. The shop id is reset when user is logging in to subshops, when new subshops are created also in modules. So this should be taken into account when refactoring oxconfig.

keywan.ghadami

2016-05-15 22:13

developer   ~0011583

there is a pull request related to that issue:
https://github.com/OXID-eSales/oxideshop_ce/pull/373

i know two workarounds
1. change the shopid within a new php process and set the shopid early e.g. by $_POST['shp'] so everything gets reloaded with the correct shopid
2. clear oxconfig from registry, call setConfig on once on every objecttype you use (also the indirectly used objecttypes) clear all objects that may hold the config object or derivated data)

keywan.ghadami

2016-06-17 12:52

developer   ~0011651

Last edited: 2016-06-17 12:56

View 2 revisions

this issues effects ERP Module, it does not have the correct subshop configuration when importing things into subshop, so e.g. it would sends the wrong hostname in invalidation request to varnish server. There is module available, that fixed that for at least that use case.

-- EDIT --
there is a related ticket to that ERP module, so maybe ERP related issues can be worked around by using sub shop specific login.
----------